#include <bits/stdc++.h>
using namespace std;


int resenja[32][500010];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    
	int n,q;
	cin >> n >> q;
	vector<int> v;
	vector<int> v2;
	for(int i=0; i<n; i++) {
		int a;
		cin >> a;
		v.push_back(a);
		
		int j=32 - __builtin_clz(a);
		v2.push_back(j);
	}
	
	for(int i=0; i<32; i++){
	    for(int j =1; j<n+1; j++){
	        if(v2[j-1]==i) resenja[i][j]=resenja[i][j-1]+1;
	        else resenja[i][j]=resenja[i][j-1];
	    }}

	for(int k=0; k<q; k++) {
		int l,r;
		cin >> l >> r;
		int najvise=0;
		for(int i=1; i<32;i++){
		    int npomoc=0;
		    npomoc=resenja[i][r]-resenja[i][l-1];
		    if(npomoc>najvise)najvise=npomoc;
		}
		
        cout <<najvise<< ' ';
	}
	

	return 0;
}